/* $Id: pfctl.c,v 1.1.1.1 2005/04/06 11:06:23 glebius Exp $ */

#include <sys/types.h>
#include <errno.h>
#include <unistd.h>

#include "pfmon.h"

#define	PFCTL_PATH	"/sbin/pfctl"
#define	PFCTL	"pfctl"
#define	ADD	"add"
#define	DEL	"delete"

int
pfctl(int cmd, char *table, char *address)
{
	char *cmdstr;
	int rval;

	/* Check that command is correct. */
	switch (cmd) {
	case CMD_ADD:
		cmdstr = ADD;
		break;
	case CMD_DELETE:
		cmdstr = DEL;
		break;
	default:
		errno = EINVAL;
		return (-1);
	}

	/* Fork child and execute pfctl in it. */
	rval = fork();
	if (rval < 0)
		return (-1);

	if (rval == 0) {
		close(STDOUT_FILENO);
		close(STDERR_FILENO);
		(void )execl(PFCTL_PATH, PFCTL, "-t", table, "-T",
		     cmdstr, address, NULL);
	}

	return (0);
}
