/* $Id: pfmon.h,v 1.7 2012/01/10 10:49:04 glebius Exp $ */

#include <sys/socket.h>
#include <sys/queue.h>

#include <net/if.h>
#include <net/pfvar.h>

#define	AI2IP(ai)	inet_ntoa(((struct sockaddr_in *)(ai)->ai_addr)->sin_addr)
#define	AI2PORT(ai)	ntohs(((struct sockaddr_in *)(ai)->ai_addr)->sin_port)

/* A pf table. */
struct table {
	char		name[PF_TABLE_NAME_SIZE+1];	/* pf(4) table */
	int		count;
	SLIST_ENTRY(table)	link;
};

/* A target to be monitored. */
struct target {
	int		sock;		/* Socket fd. */
	struct addrinfo	*ai;		/* Host and port. */
	struct table	*table;		/* Pointer to table. */
	struct timespec	timo;		/* Timeout. */
	struct timespec	interval;	/* Interval. */
	struct timespec	last;		/* Last check time. */
	struct timespec	start;		/* connect() start time. */
	enum {				/* Socket state. */
		SS_NOSOCKET = 0,
		SS_DISCONNECTED,
		SS_ISCONNECTING,
		SS_CONNECTED,
		SS_DONE,
	} ss;
	enum {				/* Target state. */
		STATE_UNCHECKED = 0,
		STATE_UP,
		STATE_DOWN,
	} state;
	SLIST_ENTRY(target)	link;
};

SLIST_HEAD(thead_t, target);
SLIST_HEAD(tabhead_t, table);
extern struct thead_t	thead;
extern struct tabhead_t	tabhead;

#ifndef	PREFIX
#define	PREFIX	"/"
#endif

/* Default config file. */
#define	PATH_CFG_FILE	PREFIX "/etc/pfmon.conf"
extern char *cfgfile;

void config(const char *);

/* Commands for pfctl(). */
enum {
	CMD_ADD	= 1,
	CMD_DELETE,
};
int pfctl(int, char *, char *);
